package adt.client;

import adt.dto.Asset;
import adt.dto.Node;
import adt.entity.ScanInfo;
import adt.entity.Vlan;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestMethod;

import java.util.List;

@FeignClient(name = "main-node", url = "${main-node.address}:${main-node.port}")
public interface MainNodeClient {

    @RequestMapping(value = "/vlans", method = RequestMethod.POST)
    Long sendAssets(Asset asset, @RequestParam String token);

    @RequestMapping(value = "/configurations", method = RequestMethod.GET)
    Node initialize(@RequestParam String token);

    @RequestMapping(value="/ip", method = RequestMethod.GET)
    int checkIP(@RequestParam String params);

}
