package adt.client;

import adt.dto.Asset;
import adt.dto.Node;
import adt.entity.ScanInfo;
import adt.entity.Vlan;
import org.springframework.beans.factory.annotation.Value;
import lombok.extern.slf4j.Slf4j;
import java.util.List;

import java.util.List;
import java.util.concurrent.Executors;
import javax.servlet.http.HttpServletRequest;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.ObjectWriter;
import com.fasterxml.jackson.databind.*;
import com.fasterxml.jackson.core.JsonProcessingException;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;

import java.io.FileWriter;
import java.io.IOException;
import java.io.*;

import java.util.Arrays;
import java.util.ArrayList;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.core.Response.Status;

import java.util.*;

import java.net.*;

import org.apache.http.client.methods.*;
import org.apache.http.impl.client.*;
import org.apache.http.entity.mime.*;
import org.apache.http.entity.*;
import org.apache.http.*;
import org.apache.http.util.*;

import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.json.simple.JSONArray;

import com.fasterxml.jackson.databind.DeserializationFeature;


@Slf4j
@Service
public class MainNodeCom {

    @Value("${main-node.address}")
    private String mainNodeAddress;
    @Value("${main-node.port}")
    private String mainNodePort;


    public Long sendAssets(Asset asset, String token){

        String urlQuery = "http://" + mainNodeAddress + ":" + mainNodePort + "/vlans?token=" + token;

        log.info("SENDING ASSETS TO: {}", urlQuery);


        log.info("SENDING THESE ASSETS: \n{}", asset);


        Long newDelay = null;

        try {
            URL url = new URL(urlQuery);

            HttpURLConnection con = (HttpURLConnection) url.openConnection();
            con.setRequestMethod("POST");
            con.setRequestProperty("Content-Type", "application/json; utf-8");
            con.setRequestProperty("Accept", "application/json");
            con.setDoOutput(true);

            final ByteArrayOutputStream out = new ByteArrayOutputStream();
            final ObjectMapper mapper = new ObjectMapper();

            mapper.writeValue(out, asset);

            final byte[] data = out.toByteArray();

            try (OutputStream os = con.getOutputStream()) {
                //byte[] input = jsonInputString.getBytes("utf-8");
                os.write(data, 0, data.length);
            }

            try (BufferedReader br = new BufferedReader(
                    new InputStreamReader(con.getInputStream(), "utf-8"))) {

                StringBuilder response = new StringBuilder();
                String responseLine = null;

                while ((responseLine = br.readLine()) != null) {

                    response.append(responseLine.trim());
                }

                newDelay = Long.parseLong(response.toString());

            } catch (Exception ex) {
                // handled
                log.info("##############{}",ex);
            }

        } catch (Exception ex) {
            // handled
            log.info("##############{}",ex);

        }

        return newDelay;

    }

    public Node initialize(String token){

        log.info("[--INITIALIZATION PROCESS--] Querying the Main Node for a scanning configuration...");

        String urlQuery = "http://" + mainNodeAddress + ":" + mainNodePort + "/configurations?token=" + token;

        Node node = null;

        try {
            URL url = new URL(urlQuery);

            HttpURLConnection con = (HttpURLConnection) url.openConnection();
            con.setRequestMethod("GET");
            con.setRequestProperty("Content-Type", "application/json; utf-8");
            con.setRequestProperty("Accept", "application/json");
            con.setDoOutput(true);

            try (BufferedReader br = new BufferedReader(
                    new InputStreamReader(con.getInputStream(), "utf-8"))) {

                StringBuilder response = new StringBuilder();
                String responseLine = null;

                while ((responseLine = br.readLine()) != null) {

                    response.append(responseLine.trim());
                }

                ObjectMapper objectMapper = new ObjectMapper().configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
                node = objectMapper.readValue(response.toString(), Node.class);

            } catch (Exception ex) {
                // handled
                log.info("##############{}",ex);
            }

        } catch (Exception ex) {
            // handled
            log.info("##############{}",ex);

        }

        return node;

    }


    public int checkIP(String token, String clientIP, String mac){

        log.info("[--DHCP SNIFING PROCESS--] Querying the Main Node for checking the existence of records for IP {}.", clientIP);

        String urlQuery = "http://" + mainNodeAddress + ":" + mainNodePort + "/presence_check?ip=" + clientIP + "&mac=" + mac + "&token=" + token;

        int answer = -1;

        try {
            URL url = new URL(urlQuery);

            HttpURLConnection con = (HttpURLConnection) url.openConnection();
            con.setRequestMethod("GET");
            con.setRequestProperty("Content-Type", "application/json; utf-8");
            con.setRequestProperty("Accept", "application/json");
            con.setDoOutput(true);

            try (BufferedReader br = new BufferedReader(
                    new InputStreamReader(con.getInputStream(), "utf-8"))) {

                StringBuilder response = new StringBuilder();
                String responseLine = null;

                while ((responseLine = br.readLine()) != null) {

                    response.append(responseLine.trim());
                }

                answer = Integer.parseInt(response.toString());

            } catch (Exception ex) {
                // handled
                log.info("##############{}",ex);
            }

        } catch (Exception ex) {
            // handled
            log.info("##############{}",ex);

        }

        return answer;
    }


}
