package adt.dto;

import adt.entity.Host;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import java.util.List;
import java.util.Date;
import adt.entity.Port;

import javax.persistence.Id;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class HostDto {

    @Id
    @JsonProperty("ip_address")
    private String ip;

    @JsonProperty("hostname")
    private String hostname;

    @JsonProperty("mac_address")
    private String mac;

    @JsonProperty("mac_manufacturer")
    private String macManufacturer;

    @JsonProperty("timestamp_device_scan_start")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date timestamp_ini;

    @JsonProperty("timestamp_device_scan_end")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date timestamp_end;

    @JsonProperty("ports")
    private List<Port> ports;

    public static HostDto createHostDto(String ip, String hostname, String mac) {
        HostDto host = new HostDto();
        host.setIp(ip);
        host.setHostname(hostname);
        host.setMac(mac);
        host.setMacManufacturer("");
        return host;
    }
}
