package adt.entity;

import lombok.Data;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;

import javax.persistence.*;

import org.apache.commons.codec.digest.DigestUtils;

@Data
@Entity
public class Port {

    //@GeneratedValue(strategy = GenerationType.IDENTITY)
    @Id
    @JsonProperty("id")
    private String id;

    @JsonProperty("port")
    private String portNumber;

    @ManyToOne
    @JsonIgnore
    private Host host;

    @JsonProperty("service")
    private String serviceRunning;

    @JsonProperty("service_version")
    private String serviceVersion;

    @JsonProperty("discovery_method")
    private String discoveryMethod;

    @JsonProperty("protocol")
    private String protocol;

    @JsonProperty("state")
    private String state;

    @JsonProperty("discovery_method_trigger")
    private String discoveryMethodTrigger;

    public static Port createPort(String portNumber, Host host, String protocol, String discoveryMethod) {
        Port port = new Port();
        String generatedHash = DigestUtils.md5Hex( DigestUtils.md5Hex(portNumber) + DigestUtils.md5Hex(host.getIp()) );

        //System.out.println(generatedHash);

        port.setId(generatedHash);
        port.setPortNumber(portNumber);
        port.setHost(host);
        port.setProtocol(protocol);
        port.setDiscoveryMethodTrigger(discoveryMethod);
        return port;
    }

    @Override
    public String toString() {
        return String.format("Port %s open on host %s with protocol %s", portNumber, host.getIp(), protocol);
    }
}
