package adt.newportdetection.runner;

import adt.dto.Asset;
import adt.entity.Host;
import adt.entity.Port;
import adt.entity.ScanInfo;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ListAllPortDetection {
    private boolean primer_scan;
    // Mapa de key ip y value otro mapa con key y value el puerto que ya tenga esa ip;
    private Map<String,Map<Integer,Integer>> mapa;
    // Lista "oficial" de todos los envios al MainNode
    private ArrayList<PortDetection> lista;

    public ListAllPortDetection() {
        this.primer_scan = true;
        this.mapa = new HashMap<>();
        this.lista = new ArrayList<>();
    }
    public void addScan(List<ScanInfo> asset){
        // Cuando llega una seguna scan
        if (!this.primer_scan){
            // Ya ha habido un segundo
            this.lista = new ArrayList<>();
            this.mapa = new HashMap<>();
        }
        this.primer_scan = false;
        addDHCP(asset);
    }
    public void addDHCP(List<ScanInfo> asset){
        asset.forEach(e ->{
            List<Host> hosts = e.getHost();
            for (int i = 0; i < hosts.size(); i++){
                Host host = hosts.get(i);
                Map<Integer,Integer> map_port = null;
                if ((map_port = mapa.get(host.getIp())) != null){
                    // Esta ip ya esta en el mapa
                    List<Port> ports = host.getPorts();
                    for (int j = 0; j < ports.size();j++){
                        Port port = ports.get(j);
                        if (!map_port.containsKey(port.getPortNumber())){
                            map_port.put(Integer.parseInt(port.getPortNumber()),Integer.parseInt(port.getPortNumber()));
                            lista.add(new PortDetection("",host.getIp(),Integer.parseInt(port.getPortNumber()),0));
                        }
                    }
                }else {
                    // Esta ip no esta en el mapa
                    Map<Integer,Integer> mapa_aux = new HashMap<>();
                    List<Port> ports = host.getPorts();
                    for (int j = 0 ; j < ports.size(); j++){
                        Port port = ports.get(j);
                        mapa_aux.put(Integer.parseInt(port.getPortNumber()),Integer.parseInt(port.getPortNumber()));
                        lista.add(new PortDetection("",host.getIp(),Integer.parseInt(port.getPortNumber()), 0));
                    }
                    mapa.put(host.getIp(),mapa_aux);
                }
            }
        });
    }
    public void addNewPort(ListPortDetection listPortDetection){
        for(int i = 0; i< listPortDetection.getLista().size(); i++){
            PortDetection portDetection = listPortDetection.getLista().get(i);
            Map<Integer,Integer> mapa_ports = null;
            if ((mapa_ports = mapa.get(portDetection.getIp())) != null){
                // Esta ya esa ip en el mapa
                if (!mapa_ports.containsKey(portDetection.getPort())){
                    mapa_ports.put(portDetection.getPort(), portDetection.getPort());
                }
            }else {
                // No esta esa ip en el mapa
                Map<Integer,Integer> mapa_puertos = new HashMap<>();
                mapa_puertos.put(portDetection.getPort(), portDetection.getPort());
                mapa.put(portDetection.getIp(),mapa_puertos);
                lista.add(new PortDetection("",portDetection.getIp(), portDetection.getPort(), 0));
            }
        }
    }
}
