package adt.newportdetection.runner;

import org.springframework.stereotype.Component;

import javax.persistence.Entity;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Component
public class ListPortDetection {
    private List<PortDetection> lista;

    public Map<String, Map<Integer, Integer>> getIp_puertos() {
        return ip_puertos;
    }

    private Map<String,Map<Integer, Integer>> ip_puertos;

    public ListPortDetection(){
        this.lista = new ArrayList<>();
        this.ip_puertos = new HashMap();
    }
    public void addNewPort(PortDetection portDetection){
        Map<Integer, Integer> aux;
        if (ip_puertos.containsKey(portDetection.getIp())){
            // Ya esta esa ip en la lista
            aux = ip_puertos.get(portDetection.getIp());
            if (!aux.containsKey(portDetection.getPort())){
                aux.put(portDetection.getPort(), portDetection.getPort());
                lista.add(portDetection);
            }
        }else {
            // No existe esa IP en el mapa
            aux = new HashMap<>();
            aux.put(portDetection.getPort(), portDetection.getPort());
            ip_puertos.put(portDetection.getIp(), aux);
            lista.add(portDetection);
        }
    }

    public List<PortDetection> getLista() {
        return lista;
    }

    @Override
    public String toString() {
        return "ListPortDetection{" +
                "lista=" + lista.toString() +
                ", ip_puertos=" + ip_puertos.toString() +
                '}';
    }
}

