package adt.newportdetection.runner;

import adt.dto.Asset;
import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.StandardCharsets;
import java.util.List;


@Slf4j
@Service
public class SendInfoToMain {

    @Value("${main-node.address}")
    private String mainNodeAddress;
    @Value("${main-node.port}")
    private String mainNodePort;

    public Long sendInfo(Asset asset, String token){

        String urlQuery = "http://" + mainNodeAddress + ":" + mainNodePort + "/sniffing?token=" + token;

        log.info("SENDING ASSETS TO: {}", urlQuery);


        log.info("SENDING THESE ASSETS: \n{}", asset);


        Long newDelay = null;

        try {
            URL url = new URL(urlQuery);

            HttpURLConnection con = (HttpURLConnection) url.openConnection();
            con.setRequestMethod("POST");
            con.setRequestProperty("Content-Type", "application/json; utf-8");
            con.setRequestProperty("Accept", "application/json");
            con.setDoOutput(true);

            final ByteArrayOutputStream out = new ByteArrayOutputStream();
            final ObjectMapper mapper = new ObjectMapper();

            mapper.writeValue(out, asset);

            final byte[] data = out.toByteArray();

            try (OutputStream os = con.getOutputStream()) {
                //byte[] input = jsonInputString.getBytes("utf-8");
                os.write(data, 0, data.length);
            }

            try (BufferedReader br = new BufferedReader(
                    new InputStreamReader(con.getInputStream(), StandardCharsets.UTF_8))) {

                StringBuilder response = new StringBuilder();
                String responseLine = null;

                while ((responseLine = br.readLine()) != null) {

                    response.append(responseLine.trim());
                }

                newDelay = Long.parseLong(response.toString());

            } catch (Exception ex) {
                // handled
                log.info("##############{}",ex);
            }

        } catch (Exception ex) {
            // handled
            log.info("##############{}",ex);

        }

        return newDelay;

    }
}
