package adt.repository;

import adt.entity.ScanInfo;
import adt.entity.Host;
import org.springframework.data.jpa.repository.JpaRepository;
import java.util.List;
import java.util.Date;

public interface HostRepository extends JpaRepository<Host, String> {

    List<Host> findAllByVlanName(String VlanName);
    List<Host> findAllByIp(String ip);
    List<Host> findAllByVlanNameAndDiscoveryMethod(String VlanName, String discoveryMethod);
    long deleteByDiscoveryMethod(String discoveryMethod);
    long deleteAllByScanInfoAndDiscoveryMethod(ScanInfo scanInfo, String discoveryMethod);
    List<Host> findAllByScanInfoAndDiscoveryMethod(ScanInfo scanInfo, String discoveryMethod);
}
