package adt.repository;

import java.util.Date;
import adt.entity.ScanInfo;
import adt.entity.Host;
import org.springframework.data.jpa.repository.JpaRepository;
import java.util.List;

public interface ScanInfoRepository extends JpaRepository<ScanInfo, String> {

    ScanInfo findFirstByDiscoveryMethodOrderByEndTimestampScan(String discoveryMethod);
    List<ScanInfo> findByVlanNameIn(List<String> vlan_names);
    List<ScanInfo> findFirstByDiscoveryMethodAndVlanNameInOrderByEndTimestampScan(String discoveryMethod, List<String> vlan_names);
    long deleteByDiscoveryMethod(String discoveryMethod);
    long deleteAllByIniTimestampScanAndDiscoveryMethod(Date time, String discoveryMethod);

    List<ScanInfo> findAllByIniTimestampScanAndDiscoveryMethod(Date iniTimestampScan, String discoveryMethod);

}
