package adt.scanner;

import adt.entity.Host;
import com.martiansoftware.macnificent.MacAddress;
import com.martiansoftware.macnificent.Oui;
import com.martiansoftware.macnificent.OuiRegistry;
import lombok.extern.slf4j.Slf4j;

import java.io.IOException;
import java.io.InputStream;

@Slf4j
public class MacScanner {

    private static MacScanner MAC_SCANNER = null;
    private OuiRegistry ouiRegistry;

    public synchronized static MacScanner getMacScanner() {
        if (MAC_SCANNER == null) {
            MAC_SCANNER = new MacScanner();
        }
        return MAC_SCANNER;
    }

    public String getMacManufacturer(Host host) {

        if (host.getMac() != null && host.getMac().length() > 0 && !host.getMac().equals("null")) {
            MacAddress macAddress = new MacAddress(host.getMac());
            if (!macAddress.toString().equals("null")){
                Oui oui = ouiRegistry.getOui(macAddress);
                if (oui != null)
                    return oui.getManufacturer();
            }
        }

        return null;

    }

    private MacScanner() {
        InputStream ouiData = getClass().getClassLoader().getResourceAsStream("macnificent.dat");
        try {
            this.ouiRegistry = new OuiRegistry(ouiData);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

}
