package adt.service;

import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class OsDetectorService {

    private static String OS = System.getProperty("os.name").toLowerCase();

    public enum OperatingSystem {
        WINDOWS, MAC, UNIX, SOLARIS, UNKNOWN
    }

    public static boolean isWindows() {
        return (OS.contains("win"));
    }

    public static boolean isMac() {
        return (OS.contains("mac"));
    }

    public static boolean isUnix() {
        return (OS.contains("nix") || OS.contains("nux") || OS.indexOf("aix") > 0);
    }

    public static boolean isSolaris() {
        return (OS.contains("sunos"));
    }

    OperatingSystem getOS() {
        if (isWindows())
            return OperatingSystem.WINDOWS;
        if (isMac())
            return OperatingSystem.MAC;
        if (isUnix())
            return OperatingSystem.UNIX;
        if (isSolaris())
            return OperatingSystem.SOLARIS;
        else
            return OperatingSystem.UNKNOWN;
    }

    // ip r | grep -E 'default.*wlp3s0' 
}
