package adt.tcpdump;

import java.lang.Thread;
import adt.tcpdump.runner.TCPDumpRunner;
import adt.tcpdump.runner.TCPDumpRunnerImpl;
import adt.repository.HostRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import adt.repository.*;
import adt.service.PortScannerService;
import adt.service.SendAssetService;
import adt.client.MainNodeCom;
import org.springframework.beans.factory.annotation.Value;

//@Service
public class TCPDumpThread extends Thread {

    private String token;
    private final MainNodeCom mainNodeCom;
    private final PortScannerService portScannerService;
    private final SendAssetService sendAssetService;
    private String ip;
    private String vlanName;
    private String nodeIp;

    private final PortRepository portRepository;
    private final ScanInfoRepository scanInfoRepository;
    private final HostRepository hostRepository;

    @Autowired
    public TCPDumpThread(String token, MainNodeCom mainNodeCom, SendAssetService sendAssetService, PortScannerService portScannerService, String nodeIp, String ip, String vlanName, HostRepository hostRepository, PortRepository portRepository, ScanInfoRepository scanInfoRepository) {

        this.token = token;
        this.scanInfoRepository = scanInfoRepository;
        this.portRepository = portRepository;
        this.hostRepository = hostRepository;
        this.nodeIp = nodeIp;
        this.mainNodeCom = mainNodeCom;
        this.ip = ip;
        this.vlanName = vlanName;
        this.sendAssetService = sendAssetService;
        this.portScannerService = portScannerService;
    }

    @Override
    public void run() {

        TCPDumpRunner tcpRunner = new TCPDumpRunnerImpl(mainNodeCom, sendAssetService, portScannerService, nodeIp, token, ip, vlanName, hostRepository, portRepository, scanInfoRepository);
        tcpRunner.sniffTraffic();
    }


}